#ifndef __DEFS_H
#define __DEFS_H

typedef int size_t;

typedef unsigned char   byte;	 //8bits
typedef unsigned short  word;	 //16bits
typedef unsigned int    dword;	 //32bits
typedef unsigned long   qword;	 //64bits

#define multiboot_magic	0x1badb002

#define NULL	(void *)0

typedef struct multiboot_info
{

 unsigned long flags;
 unsigned long mem_lower;
 unsigned long mem_upper;
 unsigned long boot_device;

}multiboot_info_t;

/******physical memory manager*****/

#define page_size	4096
#define	start_page	0x1000
#define	start_vga	0xA0000
dword memorysize;
dword kernelend;

/*********************************/

typedef unsigned int physaddr_t;
typedef unsigned int virtaddr_t;

#define	success			0
#define	nomem			-1	//no enough memory
#define	invparam		-2	//invalid parameter

#endif