#include "str.h"

unsigned char *memcpy(unsigned char *dest,unsigned char *src,int count)
{
 const char *sp = (const char *)src;
 char *dp = (char *)dest;
 for(; count!=0; count--) *dp++ = *sp++;
 return dest;
}

void *memset(void *dest, char val, size_t count)
{
    char *temp = (char *)dest;
    for( ; count != 0; count--) *temp++ = val;
    return dest;
}

void *memsetw(unsigned short *dest,unsigned short val, size_t count)
{
    unsigned short *temp = (unsigned short *)dest;
    for( ; count != 0; count--) *temp++ = val;
    return dest;
}

int strlen(const char *str)
{
 int length;
 for(length=0;*str!='\0';str++) length++;
 return length;
}

unsigned char inportb (unsigned short _port)
{
    unsigned char rv;
    __asm__ __volatile__ ("inb %1, %0" : "=a" (rv) : "dN" (_port));
    return rv;
}

void outportb (unsigned short _port, unsigned char _data)
{
    __asm__ __volatile__ ("outb %1, %0" : : "dN" (_port), "a" (_data));
}

intTstring(char *buf,char base,int number)
{
 static char digits[] = "0123456789abcdef";
	char *p = buf;
	unsigned long uns = number;
	int divisor = 10;
 
   // If we are in decimal base invert the signe if necessary
	if (base == 'd' && number < 0) {
		*p = '-';
		p++;	buf++;
		uns = -number;
	} else if (base == 'x') { 
		divisor = 16;
		*p = '0'; 
		*(p+1) = 'x';
		p +=2;
		buf +=2;
	}	else if(base != 'u')
		*buf = 0;
	
	/* We will extract digits from the right by dividing
		by base and fetching the remainder */
    do {
		long remainder = uns % divisor;
		*p = digits[remainder];
		*p++;
	}  while (uns /= divisor);
 
   // add a zero to terminate string
   *p = 0;
 
	// No we must revert the generated string
	char *head, *tail;
	head	= buf;   // head will point to the first char in buf
	tail = p - 1;		// and tail to the last char
	
	while (head < tail) {
		char tmp = *head;
		*head = *tail;
		*tail = tmp;
		head++;
		tail--;
	}
}





































































